Index: /palm/trunk/SOURCE/advec_v_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_v_up.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_v_up.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -95,5 +95,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nysv, nzb_v_inner, nzt
+           ONLY:  nxl, nxr, nyn, nysv, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -113,5 +113,5 @@
        DO  i = nxl, nxr
           DO  j = nysv, nyn
-             DO  k = nzb_v_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
 !
 !--             x-direction
@@ -120,8 +120,12 @@
                 IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( v(k,j,i) - v(k,j,i-1) ) * ddx
+                                         ( v(k,j,i) - v(k,j,i-1) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( v(k,j,i+1) - v(k,j,i) ) * ddx
+                                         ( v(k,j,i+1) - v(k,j,i) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                 ENDIF
 !
@@ -130,8 +134,12 @@
                 IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( v(k,j,i) - v(k,j-1,i) ) * ddy
+                                         ( v(k,j,i) - v(k,j-1,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( v(k,j+1,i) - v(k,j,i) ) * ddy
+                                         ( v(k,j+1,i) - v(k,j,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                 ENDIF
 !
@@ -141,8 +149,12 @@
                 IF ( wkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
-                                         ( v(k,j,i) - v(k-1,j,i) ) * ddzu(k)
+                                         ( v(k,j,i) - v(k-1,j,i) ) * ddzu(k)   &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
-                                         ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)
+                                         ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                 ENDIF
 
@@ -171,5 +183,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_v_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -187,5 +199,5 @@
 
 
-       DO  k = nzb_v_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
 !
 !--       x-direction
@@ -194,8 +206,12 @@
           IF ( ukomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
-                                         ( v(k,j,i) - v(k,j,i-1) ) * ddx
+                                         ( v(k,j,i) - v(k,j,i-1) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
-                                         ( v(k,j,i+1) - v(k,j,i) ) * ddx
+                                         ( v(k,j,i+1) - v(k,j,i) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
           ENDIF
 !
@@ -204,8 +220,12 @@
           IF ( vkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
-                                         ( v(k,j,i) - v(k,j-1,i) ) * ddy
+                                         ( v(k,j,i) - v(k,j-1,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
-                                         ( v(k,j+1,i) - v(k,j,i) ) * ddy
+                                         ( v(k,j+1,i) - v(k,j,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
           ENDIF
 !
@@ -214,8 +234,12 @@
           IF ( wkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
-                                         ( v(k,j,i) - v(k-1,j,i) ) * ddzu(k)
+                                         ( v(k,j,i) - v(k-1,j,i) ) * ddzu(k)   &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
           ELSE
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
-                                         ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)
+                                         ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
           ENDIF
 
Index: /palm/trunk/SOURCE/advec_w_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_w_pw.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_w_pw.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -96,5 +96,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb_w_inner, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -115,5 +115,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_w_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
                 tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                        &
                          ( w(k,j,i+1) * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )     &
@@ -124,5 +124,7 @@
                          - w(k-1,j,i) * ( w(k,j,i) + w(k-1,j,i) ) )            &
                                                                   * ddzu(k+1)  &
-                                                      )
+                                                      )                        &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
              ENDDO
           ENDDO
@@ -149,5 +151,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_w_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -165,5 +167,5 @@
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
-       DO  k = nzb_w_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
           tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                              &
                          ( w(k,j,i+1) * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )     &
@@ -174,5 +176,7 @@
                          - w(k-1,j,i) * ( w(k,j,i) + w(k-1,j,i) ) )            &
                                                                   * ddzu(k+1)  &
-                                                )
+                                                )                              &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
        ENDDO
     END SUBROUTINE advec_w_pw_ij
Index: /palm/trunk/SOURCE/advec_w_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_w_up.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_w_up.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! topography representation via flags
 ! 
 ! Former revisions:
@@ -95,5 +95,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb_w_inner, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -112,5 +112,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_w_inner(j,i)+1, nzt-1
+             DO  k = nzb+1, nzt-1
 !
 !--             x-direction
@@ -119,8 +119,12 @@
                 IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( w(k,j,i) - w(k,j,i-1) ) * ddx
+                                         ( w(k,j,i) - w(k,j,i-1) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
-                                         ( w(k,j,i+1) - w(k,j,i) ) * ddx
+                                         ( w(k,j,i+1) - w(k,j,i) ) * ddx       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                 ENDIF
 !
@@ -130,8 +134,12 @@
                 IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( w(k,j,i) - w(k,j-1,i) ) * ddy
+                                         ( w(k,j,i) - w(k,j-1,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
-                                         ( w(k,j+1,i) - w(k,j,i) ) * ddy
+                                         ( w(k,j+1,i) - w(k,j,i) ) * ddy       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                 ENDIF
 !
@@ -139,8 +147,12 @@
                 IF ( w(k,j,i) > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - w(k,j,i) *                      &
-                                         ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+                                         ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)   &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                 ELSE
                    tend(k,j,i) = tend(k,j,i) - w(k,j,i) *                      &
-                                         ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)
+                                         ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                 ENDIF
 
@@ -169,5 +181,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_w_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -184,5 +196,5 @@
 
 
-       DO  k = nzb_w_inner(j,i)+1, nzt-1
+       DO  k = nzb+1, nzt-1
 !
 !--       x-direction
